Index: /trunk/doc/ReleaseNotes.os2
===================================================================
--- /trunk/doc/ReleaseNotes.os2	(revision 2263)
+++ /trunk/doc/ReleaseNotes.os2	(revision 2264)
@@ -10,4 +10,98 @@
 
 
+GCC v3.3.5 / LIBC v0.6 - Relase Candidate 1:
+--------------------------------------------
+
+    New features:
+
+        o Replaced the BSD regex with the GLIBC one.
+
+        o Replaced the BSD getopt with the GLIBC one adding optreset
+          for BSD compatability.
+
+        o Added libcrypt from GLIBC.
+
+        o Added argp from GLIBC.
+
+        o Added obstack from GLIBC.
+
+        o Finally added a crude [v]asprintf() implementation.
+
+        o Added missing math bits from GLIBC.
+
+        o New functions:
+          rawmemchr(), strchrnul(), fgets_unlocked(), gets_unlocked(),
+          fwide(), asprintf(), vasprintf(), get_current_dir_name(),
+          getdelim(), getline(), getlogin_r(), _getopt_internal(),
+          _getopt_internal_r(), _getopt_long_only_r(),
+          _getopt_long_r(), argp_error(), argp_failure(),
+          argp_fmtstream_ensure(), argp_fmtstream_free(),
+          argp_fmtstream_point(), argp_fmtstream_printf(),
+          argp_fmtstream_putc(), argp_fmtstream_puts(),
+          argp_fmtstream_set_lmargin(), argp_fmtstream_set_rmargin(),
+          argp_fmtstream_set_wmargin(), argp_fmtstream_update(),
+          argp_fmtstream_write(), argp_help(), argp_input(),
+          argp_make_fmtstream(), argp_parse(),
+          argp_program_bug_address(), argp_program_version(),
+          argp_program_version_hook(), argp_state_help(), argp_usage(),
+          cacos(), cacosf(), cacosh(), cacoshf(), cacoshl(), cacosl(),
+          cargf(), casin(), casinf(), casinh(), casinhf(), casinhl(),
+          casinl(), catan(), catanf(), catanh(), catanhf(), catanhl(),
+          catanl(), ccos(), ccosf(), ccosh(), ccoshf(), ccoshl(),
+          ccosl(), cexp(), cexpf(), cexpl(), clog(), clog10(),
+          clog10f(), clog10l(), clogf(), clogl(), cpow(), cpowf(),
+          cpowl(), cproj(), cprojf(), cprojl(), csin(), csinf(),
+          csinh(), csinhf(), csinhl(), csinl(), csqrt(), csqrtf(),
+          csqrtl(), ctan(), ctanf(), ctanh(), ctanhf(), ctanhl(),
+          ctanl(), exp10(), log2(), log2f(), log2l(), sincos(),
+          sincosf(), sincosl(), asinhl(), atanhl(), llrintl(),
+          lrintl(), erfcl(), erfl(), exp2l(), expm1l(), log1pl(),
+          logbl(), nearbyintl(), remainderl(), remquol(), cabsl(),
+          carg(), cargl(), gammal_r(), exp10f(), tgammaf(), tgammal(),
+          __fpu_control(), acoshl(), exp10l(), j0l(), j1l(), jnl(),
+          lgammal_r(), nexttowardl(), scalbl(), significandl(), y0l(),
+          y1l(), ynl(), gammal(), lgammal(), _obstack_allocated_p(),
+          obstack_alloc_failed_handler(), _obstack_begin(),
+          _obstack_begin_1(), obstack_exit_failure(), obstack_free(),
+          _obstack_memory_used(), _obstack_newchunk(), nftw(),
+          stpncpy(), crypt_r(), encrypt_r(), init_des(), init_des_r(),
+          md5_buffer(), md5_crypt(), md5_crypt_r(), md5_finish_ctx(),
+          md5_init_ctx(), md5_process_block(), md5_process_bytes(),
+          md5_read_ctx(), md5_stream(), setkey_r(), crypt(), encrypt(),
+          setkey(), _ufc_dofinalperm_r(), _ufc_doit_r(), _ufc_foobar(),
+          _ufc_mk_keytab_r(), _ufc_output_conversion_r(),
+          _ufc_setup_salt_r(), getmode(), optreset(), bsd_setmode(),
+          getpgid(), getsid(), setlinebuf(), re_comp(),
+          re_compile_fastmap(), re_compile_pattern(), re_exec(),
+          re_match(), re_match_2(), re_search(), re_search_2(),
+          re_set_registers() and re_set_syntax().
+
+    Bug fixes:
+
+        o Fixed various bugs related to __declspec.
+
+        o Fixed bug in alloca which was causing all -O levels
+          to break.
+
+        o Added UniStrFromUcs and UniStrToUcs to uconv.h and libos2.
+
+        o Fixed quite a few libc issues, see the ChangeLog.LIBC
+          for full details.
+
+
+    Known problems:
+
+        o Static linking not possible - will be fixed.
+
+        o Job control will only be applied to thread 1 in a process.
+          This won't change.
+
+        o Missing some process group interfaces required for
+          job control. They'll show up soon.
+
+        o The HLL debug info isn't working 100% correctly.
+
+
+
 GCC v3.3.5 / LIBC v0.6 - Beta 5:
 --------------------------------
@@ -52,49 +146,49 @@
 
         o New functions (might not be 100% correct):
-          __bindtextdomain(), __dcgettext(), __dcigettext(), 
-          __dcngettext(), __dgettext(), __dngettext(), __gettext(), 
-          __gettext_extract_plural(), __gettext_free_exp(), 
-          __gettextparse(), _nl_make_l10nflist(), __ngettext(), 
-          __textdomain(), _nl_locale_name(), on_exit(), nanosleep(), 
-          wmemcpy(), wmemchr(), wmemcmp(), wmemmove(), wmemset(), 
-          gethrtime(), _nl_expand_alias(), _nl_explode_name(), 
-          _nl_normalize_codeset(), __fbufsize(), __fpending(), 
-          getpriority(), setpriority(), nice(), sysctl(), 
-          sysctlbyname(), sysctlnametomib(), fchmod(), _chdir_os2(), 
-          fts_children(), fts_close(), fts_get_clientptr(), 
-          fts_get_stream(), fts_open(), fts_read(), fts_set(), 
-          fts_set_clientptr(), mkfifo(), futimes(), _getenv_int(), 
-          _getenv_long(), _getenv_longlong(), ftok(), semctl(), 
-          semget(), semop(), shmat(), shmctl(), shmdt(), shmget(), 
-          acosf(), acosh(), acoshf(), asinf(), asinh(), asinhf(), 
-          atan2f(), atanf(), atanh(), atanhf(), cabs(), cabsf(), 
-          cbrtf(), ceilf(), cimag(), cimagf(), cimagl(), conj(), 
-          conjf(), conjl(), cosf(), coshf(), creal(), crealf(), 
-          creall(), erf(), erfc(), erfcf(), erff(), exp2(), exp2f(), 
-          expf(), expm1(), expm1f(), truncf(), fabsf(), fdim(), 
-          fdimf(), fdiml(), fegetenv(), feholdexcept(), 
-          feraiseexcept(), fesetexceptflag(), feupdateenv(), floorf(), 
-          fma(), fmaf(), fmal(), fmax(), fmaxf(), fmaxl(), fmin(), 
-          fminf(), fminl(), fmodf(), frexpf(), hypotf(), ilogb(), 
-          ilogbf(), ilogbl(), ldexpf(), lgamma(), lgammaf(), llrint(), 
-          llrintf(), llround(), llroundf(), llroundl(), log10f(), 
-          log1p(), log1pf(), logb(), logbf(), logf(), lrint(), 
-          lrintf(), lround(), lroundf(), lroundl(), modff(), 
-          nearbyint(), nearbyintf(), nexttoward(), nexttowardf(), 
-          powf(), remainder(), remainderf(), remquo(), remquof(), 
-          rintf(), round(), roundf(), roundl(), scalbf(), scalbln(), 
-          scalblnf(), scalblnl(), scalbn(), scalbnf(), scalbnl(), 
-          signgam(), sinf(), sinhf(), sqrtf(), tanf(), tanhf(), 
-          tgamma(), drem(), dremf(), finite(), finitef(), gamma(), 
-          gammaf(), gammaf_r(), gamma_r(), j0(), j0f(), j1(), j1f(), 
-          jn(), jnf(), lgammaf_r(), lgamma_r(), scalb(), 
-          significand(), significandf(), powl(), y0(), y0f(), y1(), 
-          y1f(), yn(), ynf(), arc4random(), arc4random_addrandom(), 
-          arc4random_stir(), _mktemp(), mkdtemp(), mkstemps(), 
-          clearerr_unlocked(), feof_unlocked(), ferror_unlocked(),  
-          fgetc_unlocked(), fileno_unlocked(), flockfile(), 
-          ftrylockfile(), funlockfile(), getchar_unlocked(), 
-          getc_unlocked(), putchar_unlocked(), fputc_unlocked(), 
-          putc_unlocked(), fputs_unlocked(), puts_unlocked() and 
+          __bindtextdomain(), __dcgettext(), __dcigettext(),
+          __dcngettext(), __dgettext(), __dngettext(), __gettext(),
+          __gettext_extract_plural(), __gettext_free_exp(),
+          __gettextparse(), _nl_make_l10nflist(), __ngettext(),
+          __textdomain(), _nl_locale_name(), on_exit(), nanosleep(),
+          wmemcpy(), wmemchr(), wmemcmp(), wmemmove(), wmemset(),
+          gethrtime(), _nl_expand_alias(), _nl_explode_name(),
+          _nl_normalize_codeset(), __fbufsize(), __fpending(),
+          getpriority(), setpriority(), nice(), sysctl(),
+          sysctlbyname(), sysctlnametomib(), fchmod(), _chdir_os2(),
+          fts_children(), fts_close(), fts_get_clientptr(),
+          fts_get_stream(), fts_open(), fts_read(), fts_set(),
+          fts_set_clientptr(), mkfifo(), futimes(), _getenv_int(),
+          _getenv_long(), _getenv_longlong(), ftok(), semctl(),
+          semget(), semop(), shmat(), shmctl(), shmdt(), shmget(),
+          acosf(), acosh(), acoshf(), asinf(), asinh(), asinhf(),
+          atan2f(), atanf(), atanh(), atanhf(), cabs(), cabsf(),
+          cbrtf(), ceilf(), cimag(), cimagf(), cimagl(), conj(),
+          conjf(), conjl(), cosf(), coshf(), creal(), crealf(),
+          creall(), erf(), erfc(), erfcf(), erff(), exp2(), exp2f(),
+          expf(), expm1(), expm1f(), truncf(), fabsf(), fdim(),
+          fdimf(), fdiml(), fegetenv(), feholdexcept(),
+          feraiseexcept(), fesetexceptflag(), feupdateenv(), floorf(),
+          fma(), fmaf(), fmal(), fmax(), fmaxf(), fmaxl(), fmin(),
+          fminf(), fminl(), fmodf(), frexpf(), hypotf(), ilogb(),
+          ilogbf(), ilogbl(), ldexpf(), lgamma(), lgammaf(), llrint(),
+          llrintf(), llround(), llroundf(), llroundl(), log10f(),
+          log1p(), log1pf(), logb(), logbf(), logf(), lrint(),
+          lrintf(), lround(), lroundf(), lroundl(), modff(),
+          nearbyint(), nearbyintf(), nexttoward(), nexttowardf(),
+          powf(), remainder(), remainderf(), remquo(), remquof(),
+          rintf(), round(), roundf(), roundl(), scalbf(), scalbln(),
+          scalblnf(), scalblnl(), scalbn(), scalbnf(), scalbnl(),
+          signgam(), sinf(), sinhf(), sqrtf(), tanf(), tanhf(),
+          tgamma(), drem(), dremf(), finite(), finitef(), gamma(),
+          gammaf(), gammaf_r(), gamma_r(), j0(), j0f(), j1(), j1f(),
+          jn(), jnf(), lgammaf_r(), lgamma_r(), scalb(),
+          significand(), significandf(), powl(), y0(), y0f(), y1(),
+          y1f(), yn(), ynf(), arc4random(), arc4random_addrandom(),
+          arc4random_stir(), _mktemp(), mkdtemp(), mkstemps(),
+          clearerr_unlocked(), feof_unlocked(), ferror_unlocked(),
+          fgetc_unlocked(), fileno_unlocked(), flockfile(),
+          ftrylockfile(), funlockfile(), getchar_unlocked(),
+          getc_unlocked(), putchar_unlocked(), fputc_unlocked(),
+          putc_unlocked(), fputs_unlocked(), puts_unlocked() and
           fread_unlocked().
 