Index: branches/kBuild-0.1.5/Maintenance.kmk
===================================================================
--- branches/kBuild-0.1.5/Maintenance.kmk	(revision 2333)
+++ branches/kBuild-0.1.5/Maintenance.kmk	(revision 2334)
@@ -27,4 +27,6 @@
 include $(PATH_KBUILD)/header.kmk
 
+MAINTENANCE_PATCH = -p1
+
 RMTREE = $(ECHO) todo: $(RM) -Rf
 RMTREE = rm -Rf
@@ -40,19 +42,19 @@
 # Creates the 'all' tarballs.
 #
-$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)-all.tar.gz: | $$(dir $$@)
-	$(RM) -f $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)-all.tar $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)-all.tar.gz
+$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)-all.tar.gz: | $$(dir $$@)
+	$(RM) -f $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)-all.tar $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)-all.tar.gz
 	$(RMTREE)             $(PATH_TARGET)/all/
 	$(MKDIR) -p           $(PATH_TARGET)/all/
-	$(SVN) export .       $(PATH_TARGET)/all/kBuild-$(KBUILD_VERSION)/
+	$(SVN) export .       $(PATH_TARGET)/all/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)/
 	$(INSTALL) $(KBUILD_SVN_INFO_KMK) \
-	                      $(PATH_TARGET)/all/kBuild-$(KBUILD_VERSION)/SvnInfo.kmk
-	$(TAR) cvf $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)-all.tar \
-	                   -C $(PATH_TARGET)/all/ kBuild-$(KBUILD_VERSION)/
-	$(GZIP) -9 $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)-all.tar
-	$(RMTREE)             $(PATH_TARGET)/all/kBuild-$(KBUILD_VERSION)/
+	                      $(PATH_TARGET)/all/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)/SvnInfo.kmk
+	$(TAR) cvf $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)-all.tar \
+	                   -C $(PATH_TARGET)/all/ kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)/
+	$(GZIP) -9 $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)-all.tar
+	$(RMTREE)             $(PATH_TARGET)/all/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)/
 
 OTHER_CLEAN += \
-	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)-all.tar \
-	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)-all.tar.gz
+	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)-all.tar \
+	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)-all.tar.gz
 
 
@@ -77,20 +79,20 @@
 # Creates the source tarballs.
 #
-$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)-src.tar.gz: | $$(dir $$@)
-	$(RM) -f $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)-src.tar $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)-src.tar.gz
+$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)-src.tar.gz: | $$(dir $$@)
+	$(RM) -f $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)-src.tar $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)-src.tar.gz
 	$(RMTREE)             $(PATH_TARGET)/src/
 	$(MKDIR) -p           $(PATH_TARGET)/src/
-	$(SVN) export .       $(PATH_TARGET)/src/kBuild-$(KBUILD_VERSION)/
-	$(RMTREE)             $(PATH_TARGET)/src/kBuild-$(KBUILD_VERSION)/kBuild/bin
+	$(SVN) export .       $(PATH_TARGET)/src/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)/
+	$(RMTREE)             $(PATH_TARGET)/src/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)/kBuild/bin
 	$(INSTALL) $(KBUILD_SVN_INFO_KMK) \
-	                      $(PATH_TARGET)/src/kBuild-$(KBUILD_VERSION)/SvnInfo.kmk
-	$(TAR) cvf $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)-src.tar \
-	                   -C $(PATH_TARGET)/src/ kBuild-$(KBUILD_VERSION)/
-	$(GZIP) -9 $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)-src.tar
-	$(RMTREE)             $(PATH_TARGET)/src/kBuild-$(KBUILD_VERSION)/
+	                      $(PATH_TARGET)/src/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)/SvnInfo.kmk
+	$(TAR) cvf $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)-src.tar \
+	                   -C $(PATH_TARGET)/src/ kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)/
+	$(GZIP) -9 $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)-src.tar
+	$(RMTREE)             $(PATH_TARGET)/src/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)/
 
 OTHER_CLEAN += \
-	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)-src.tar \
-	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)-src.tar.gz
+	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)-src.tar \
+	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)-src.tar.gz
 
 
@@ -115,17 +117,17 @@
 # Creates the binary tarballs.
 #
-$(PATH_TARGET)/kBuild-$(KBUILD_VERSION).tar.gz: | $$(dir $$@)
-	$(RM) -f $(PATH_TARGET)/kBuild-$(KBUILD_VERSION).tar $(PATH_TARGET)/kBuild-$(KBUILD_VERSION).tar.gz
+$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH).tar.gz: | $$(dir $$@)
+	$(RM) -f $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH).tar $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH).tar.gz
 	$(RMTREE)             $(PATH_TARGET)/bin/
-	$(MKDIR) -p           $(PATH_TARGET)/bin/kBuild-$(KBUILD_VERSION)/
-	$(SVN) export kBuild/ $(PATH_TARGET)/bin/kBuild-$(KBUILD_VERSION)/kBuild/
-	$(TAR) cvf $(PATH_TARGET)/kBuild-$(KBUILD_VERSION).tar \
-	                   -C $(PATH_TARGET)/bin/ kBuild-$(KBUILD_VERSION)/
-	$(GZIP) -9 $(PATH_TARGET)/kBuild-$(KBUILD_VERSION).tar
-	$(RMTREE)             $(PATH_TARGET)/bin/kBuild-$(KBUILD_VERSION)/
+	$(MKDIR) -p           $(PATH_TARGET)/bin/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)/
+	$(SVN) export kBuild/ $(PATH_TARGET)/bin/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)/kBuild/
+	$(TAR) cvf $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH).tar \
+	                   -C $(PATH_TARGET)/bin/ kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)/
+	$(GZIP) -9 $(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH).tar
+	$(RMTREE)             $(PATH_TARGET)/bin/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)/
 
 OTHER_CLEAN += \
-	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION).tar \
-	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION).tar.gz
+	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH).tar \
+	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH).tar.gz
 
 
@@ -149,13 +151,13 @@
 #
 tarballs: \
-	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)-src.tar.gz \
-	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION).tar.gz \
+	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)-src.tar.gz \
+	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH).tar.gz \
 	$(PATH_TARGET)/kBuild-$(KBUILD_SVN_REV).tar.gz \
 	$(PATH_TARGET)/kBuild-$(KBUILD_SVN_REV)-src.tar.gz
 
 release: \
-	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION).tar.gz \
-	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)-src.tar.gz \
-	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)-all.tar.gz
+	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH).tar.gz \
+	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)-src.tar.gz \
+	$(PATH_TARGET)/kBuild-$(KBUILD_VERSION)$(MAINTENANCE_PATCH)-all.tar.gz
 
 nightly: \